Index: tests/Python/AllActions/options.dat
===================================================================
--- tests/Python/AllActions/options.dat	(revision 72b467c0c16cb89ffa723c2d2d3cb449d7f7c4df)
+++ tests/Python/AllActions/options.dat	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -225,4 +225,6 @@
 skiplines	"2"
 start-step	"0"
+steps-forward	"1"
+steps-backward	"0"
 steps	"5"
 store-grids	"0"
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision 72b467c0c16cb89ffa723c2d2d3cb449d7f7c4df)
+++ tests/regression/Makefile.am	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -134,5 +134,4 @@
 	$(srcdir)/Options/Session/testsuite-options-store-session-python.at \
 	$(srcdir)/Options/SetDefaultName/testsuite-options-set-default-name.at \
-	$(srcdir)/Options/SetWorldTime/testsuite-options-set-world-time.at \
 	$(srcdir)/Options/Verbosity/testsuite-options-verbosity.at \
 	$(srcdir)/Options/Warranty/testsuite-options-warranty.at \
@@ -241,5 +240,8 @@
 	$(srcdir)/Tesselation/Convex/testsuite-tesselation-convex-envelope.at \
 	$(srcdir)/Tesselation/NonConvex/testsuite-tesselation-non-convex-envelope.at \
-	$(srcdir)/Tesselation/TriangleMatcher/testsuite-tesselation-trianglematcher.at
+	$(srcdir)/Tesselation/TriangleMatcher/testsuite-tesselation-trianglematcher.at \
+	$(srcdir)/WorldTime/testsuite-worldtime.at \
+	$(srcdir)/WorldTime/SetWorldTime/testsuite-worldtime-set-world-time.at \
+	$(srcdir)/WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at
 
 max_jobs = 4
Index: tests/regression/Options/SetWorldTime/testsuite-options-set-world-time.at
===================================================================
--- tests/regression/Options/SetWorldTime/testsuite-options-set-world-time.at	(revision 72b467c0c16cb89ffa723c2d2d3cb449d7f7c4df)
+++ 	(revision )
@@ -1,44 +1,0 @@
-#
-#    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2008-2012 University of Bonn
-#
-#    This program is free software: you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation, either version 3 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-### molecule default name
-
-AT_SETUP([Standard Options - set world time])
-AT_KEYWORDS([options set-world-time])
-
-AT_CHECK([../../molecuilder --set-world-time 10], 0, [stdout], [stderr])
-AT_CHECK([fgrep "Current time step is now: 10" stdout], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Standard Options - set world time with Undo])
-AT_KEYWORDS([options set-world-time undo])
-
-AT_CHECK([../../molecuilder --set-world-time 10 --undo], 0, [stdout], [stderr])
-AT_CHECK([fgrep "Current time step is now again: 0" stdout], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Standard Options - set world time with Redo])
-AT_KEYWORDS([options set-world-time redo])
-
-AT_CHECK([../../molecuilder --set-world-time 10 --undo --redo], 0, [stdout], [stderr])
-AT_CHECK([fgrep "Current time step is now: 10" stdout], 0, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Options/testsuite-options.at
===================================================================
--- tests/regression/Options/testsuite-options.at	(revision 72b467c0c16cb89ffa723c2d2d3cb449d7f7c4df)
+++ tests/regression/Options/testsuite-options.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -40,7 +40,4 @@
 m4_include([Options/SetDefaultName/testsuite-options-set-default-name.at])
 
-# world time
-m4_include([Options/SetWorldTime/testsuite-options-set-world-time.at])
-
 # test that all desire parameters and count how many complain
 m4_include([Options/Empty/testsuite-options-empty-configs.at])
Index: tests/regression/WorldTime/SetWorldTime/testsuite-worldtime-set-world-time.at
===================================================================
--- tests/regression/WorldTime/SetWorldTime/testsuite-worldtime-set-world-time.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
+++ tests/regression/WorldTime/SetWorldTime/testsuite-worldtime-set-world-time.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -0,0 +1,45 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#    Copyright (C) 2016 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### set world time
+
+AT_SETUP([Worldtime - set])
+AT_KEYWORDS([worldtime set-world-time])
+
+AT_CHECK([../../molecuilder --set-world-time 10], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now: 10" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Worldtime - set with Undo])
+AT_KEYWORDS([worldtime set-world-time undo])
+
+AT_CHECK([../../molecuilder --set-world-time 10 --undo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now again: 0" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Worldtime - set with Redo])
+AT_KEYWORDS([worldtime set-world-time undo redo])
+
+AT_CHECK([../../molecuilder --set-world-time 10 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now: 10" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at
===================================================================
--- tests/regression/WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
+++ tests/regression/WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -0,0 +1,47 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2016 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### step through world time
+
+AT_SETUP([Worldtime - stepping])
+AT_KEYWORDS([worldtime step-world-time set-world-time])
+
+AT_CHECK([../../molecuilder --step-world-time --steps-forward 1], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now: 1" stdout], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder --set-world-time 4 --step-world-time --steps-backward 2], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now: 2" stdout], 0, [ignore], [ignore])
+# stepping back too far fails
+AT_CHECK([../../molecuilder --set-world-time 1 --step-world-time --steps-backward 2], 5, [stdout], [stderr])
+
+AT_CLEANUP
+
+
+AT_SETUP([Worldtime - stepping with Undo])
+AT_KEYWORDS([worldtime step-world-time set-world-time undo])
+
+AT_CHECK([../../molecuilder --set-world-time 2 --step-world-time --steps-backward  1 --undo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now again: 2" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Worldtime - stepping with Redo])
+AT_KEYWORDS([worldtime step-world-time set-world-time undo redo])
+
+AT_CHECK([../../molecuilder --set-world-time 2 --step-world-time --steps-backward 1 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "Current time step is now: 1" stdout], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/WorldTime/testsuite-worldtime.at
===================================================================
--- tests/regression/WorldTime/testsuite-worldtime.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
+++ tests/regression/WorldTime/testsuite-worldtime.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -0,0 +1,24 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2016 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+AT_BANNER([MoleCuilder - worldtime])
+
+# setting
+m4_include([WorldTime/SetWorldTime/testsuite-worldtime-set-world-time.at])
+
+# stepping
+m4_include([WorldTime/StepWorldTime/testsuite-worldtime-step-world-time.at])
Index: tests/regression/testsuite.at
===================================================================
--- tests/regression/testsuite.at	(revision 72b467c0c16cb89ffa723c2d2d3cb449d7f7c4df)
+++ tests/regression/testsuite.at	(revision 3400bb467c85efe7eb581f7b937a7a326f90ac7e)
@@ -36,4 +36,6 @@
 m4_include(Options/testsuite-options.at)
 
+m4_include(WorldTime/testsuite-worldtime.at)
+
 m4_include(Parser/testsuite-parser.at)
 